	import * as THREE from 'three';


	// rar2 rack
	export function rar2(width=800, height=2500, depth=800) {
		const kly_rackObject = new THREE.Object3D();
	
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		const materialVeryGreyDark= new THREE.MeshLambertMaterial({color: 0x242424});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x17fc03});
		const redmaterial = new THREE.MeshLambertMaterial({color: 0xff0000});
		const yellowmaterial = new THREE.MeshLambertMaterial({color: 0xcc9d02});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		
		//rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, silvermaterial);
		rrmesh.position.set( 0, 0 , -810);
		kly_rackObject.add(rrmesh);	
		
		//front yellow target
		const Ftarget = new THREE.BoxGeometry(2, 90, 700);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -815);
		kly_rackObject.add(Ftargetmesh);		
		//Rear yellow target
		const Rtarget = new THREE.BoxGeometry(2, 90, 700);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -815);
		kly_rackObject.add(Rtargetmesh);			
		
		//edge 	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const llemesh = new THREE.Mesh(llegeometry, materialGreyDark);
		llemesh.position.set( -425, 0 , -1185);
		kly_rackObject.add(llemesh);
		
		//edge lre		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const lremesh = new THREE.Mesh(lregeometry, materialGreyDark);
		lremesh.position.set( -425, 0 , -430);
		kly_rackObject.add(lremesh);		

		//edge lue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, materialGreyDark);
		luemesh.position.set( -425, 1225 , -807);
		kly_rackObject.add(luemesh);		

		//edge lde		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, materialGreyDark);
		ldemesh.position.set( -425, -1230 , -807);
		kly_rackObject.add(ldemesh);				

		//drawer1		
		const drawer1geometry = new THREE.BoxGeometry(10, 250, 630);
		const drawer1geometrymesh = new THREE.Mesh(drawer1geometry, materialGreyDark);
		drawer1geometrymesh.position.set( -400, 1000 , -810);
		kly_rackObject.add(drawer1geometrymesh);
		
		//display1 left		
		const display1leftgeometry = new THREE.BoxGeometry(50, 50, 150);
		const display1leftgeometrygeometrymesh = new THREE.Mesh(display1leftgeometry, materialVeryGreyDark);
		display1leftgeometrygeometrymesh.position.set( -400, 1050 , -1000);
		kly_rackObject.add(display1leftgeometrygeometrymesh);			
		
		//display1 right		
		const displayupgeometry2 = new THREE.BoxGeometry(50, 50, 150);
		const displayupgeometrymesh2 = new THREE.Mesh(displayupgeometry2, materialVeryGreyDark);
		displayupgeometrymesh2.position.set( -400, 1050 , -820);
		kly_rackObject.add(displayupgeometrymesh2);
		
		//selector1		
		const selector1geometry = new THREE.BoxGeometry(20, 70, 20);
		const selector1geometrymesh = new THREE.Mesh(selector1geometry, materialVeryGreyDark);
		selector1geometrymesh.position.set( -400, 940 , -1030);
		selector1geometrymesh.rotateX(Math.PI * 1.75);
		selector1geometrymesh.rotateY(Math.PI * 1.50);
		selector1geometrymesh.rotateZ(Math.PI * 1.50);
		kly_rackObject.add(selector1geometrymesh);
		
		//sfere selector1
		const sphereselector1drawer1 = new THREE.SphereGeometry(20, 10, 10);
		const sphereselector1drawer1mesh = new THREE.Mesh(sphereselector1drawer1, materialVeryGreyDark);
		sphereselector1drawer1mesh.position.set(-400, 940 , -1030);		
		kly_rackObject.add(sphereselector1drawer1mesh);
		
		//sfere drawer1 button1 
		const spherebutton1drawer1 = new THREE.SphereGeometry(20, 10, 10);
		const spherebutton1drawer1mesh = new THREE.Mesh(spherebutton1drawer1, materialVeryGreyDark);
		spherebutton1drawer1mesh.position.set(-400, 990 , -630);		
		kly_rackObject.add(spherebutton1drawer1mesh);	
		
		//sfere drawer1 button2 
		const spherebutton2drawer1 = new THREE.SphereGeometry(20, 10, 10);
		const spherebutton2drawer1mesh = new THREE.Mesh(spherebutton2drawer1, materialVeryGreyDark);
		spherebutton2drawer1mesh.position.set(-400, 990 , -550);		
		kly_rackObject.add(spherebutton2drawer1mesh);				
	
		//drawer2		
		const drawer2geometry = new THREE.BoxGeometry(10, 250, 630);
		const drawer2geometrymesh = new THREE.Mesh(drawer2geometry, materialGreyDark);
		drawer2geometrymesh.position.set( -400, 700 , -810);
		kly_rackObject.add(drawer2geometrymesh);
		
		//display2 left		
		const display1leftgeometrydrawer2 = new THREE.BoxGeometry(50, 50, 150);
		const display1leftgeometrygeometrydrawer2mesh = new THREE.Mesh(display1leftgeometrydrawer2, materialVeryGreyDark);
		display1leftgeometrygeometrydrawer2mesh.position.set( -400, 750 , -1000);
		kly_rackObject.add(display1leftgeometrygeometrydrawer2mesh);			
		
		//display2 right		
		const display2leftgeometrydrawer2 = new THREE.BoxGeometry(50, 50, 150);
		const display2leftgeometrygeometrydrawer2mesh = new THREE.Mesh(display2leftgeometrydrawer2, materialVeryGreyDark);
		display2leftgeometrygeometrydrawer2mesh.position.set( -400, 750 , -820);
		kly_rackObject.add(display2leftgeometrygeometrydrawer2mesh);
		
		//selector2		
		const selector1geometrydrawer2 = new THREE.BoxGeometry(20, 70, 20);
		const selector1geometrydrawer2mesh = new THREE.Mesh(selector1geometrydrawer2, materialVeryGreyDark);
		selector1geometrydrawer2mesh.position.set( -400, 640 , -1030);
		selector1geometrydrawer2mesh.rotateX(Math.PI * 1.75);
		selector1geometrydrawer2mesh.rotateY(Math.PI * 1.50);
		selector1geometrydrawer2mesh.rotateZ(Math.PI * 1.50);
		kly_rackObject.add(selector1geometrydrawer2mesh);
		
		//sfere selector2
		const sphereselector1drawer2 = new THREE.SphereGeometry(20, 10, 10);
		const sphereselector1drawer2mesh = new THREE.Mesh(sphereselector1drawer2, materialVeryGreyDark);
		sphereselector1drawer2mesh.position.set(-400, 640 , -1030);		
		kly_rackObject.add(sphereselector1drawer2mesh);
		
		//sfere drawer2 button1 
		const spherebutton1drawer2 = new THREE.SphereGeometry(20, 10, 10);
		const spherebutton1drawer2mesh = new THREE.Mesh(spherebutton1drawer2, materialVeryGreyDark);
		spherebutton1drawer2mesh.position.set(-400, 690 , -630);		
		kly_rackObject.add(spherebutton1drawer2mesh);	
		
		//sfere drawer2 button2 
		const spherebutton2drawer2 = new THREE.SphereGeometry(20, 10, 10);
		const spherebutton2drawer2mesh = new THREE.Mesh(spherebutton2drawer2, materialVeryGreyDark);
		spherebutton2drawer2mesh.position.set(-400, 690 , -550);		
		kly_rackObject.add(spherebutton2drawer2mesh);	
		
		//drawer3		
		const drawer3geometry = new THREE.BoxGeometry(10, 250, 630);
		const drawer3geometrymesh = new THREE.Mesh(drawer3geometry, materialGreyDark);
		drawer3geometrymesh.position.set( -400, 400 , -810);
		kly_rackObject.add(drawer3geometrymesh);
		
		//display2 left		
		const display1leftgeometrydrawer3 = new THREE.BoxGeometry(50, 50, 150);
		const display1leftgeometrygeometrydrawer3mesh = new THREE.Mesh(display1leftgeometrydrawer3, materialVeryGreyDark);
		display1leftgeometrygeometrydrawer3mesh.position.set( -400, 450 , -1000);
		kly_rackObject.add(display1leftgeometrygeometrydrawer3mesh);			
		
		//display2 right		
		const display2leftgeometrydrawer3 = new THREE.BoxGeometry(50, 50, 150);
		const display2leftgeometrygeometrydrawer3mesh = new THREE.Mesh(display2leftgeometrydrawer3, materialVeryGreyDark);
		display2leftgeometrygeometrydrawer3mesh.position.set( -400, 450 , -820);
		kly_rackObject.add(display2leftgeometrygeometrydrawer3mesh);
		
		//selector2		
		const selector1geometrydrawer3 = new THREE.BoxGeometry(20, 70, 20);
		const selector1geometrydrawer3mesh = new THREE.Mesh(selector1geometrydrawer3, materialVeryGreyDark);
		selector1geometrydrawer3mesh.position.set( -400, 340 , -1030);
		selector1geometrydrawer3mesh.rotateX(Math.PI * 1.75);
		selector1geometrydrawer3mesh.rotateY(Math.PI * 1.50);
		selector1geometrydrawer3mesh.rotateZ(Math.PI * 1.50);
		kly_rackObject.add(selector1geometrydrawer3mesh);
		
		//sfere selector2
		const sphereselector1drawer3 = new THREE.SphereGeometry(20, 10, 10);
		const sphereselector1drawer3mesh = new THREE.Mesh(sphereselector1drawer3, materialVeryGreyDark);
		sphereselector1drawer3mesh.position.set(-400, 340 , -1030);		
		kly_rackObject.add(sphereselector1drawer3mesh);
		
		//sfere drawer2 button1 
		const spherebutton1drawer3 = new THREE.SphereGeometry(20, 10, 10);
		const spherebutton1drawer3mesh = new THREE.Mesh(spherebutton1drawer3, materialVeryGreyDark);
		spherebutton1drawer3mesh.position.set(-400, 390 , -630);		
		kly_rackObject.add(spherebutton1drawer3mesh);	
		
		//sfere drawer2 button2 
		const spherebutton2drawer3 = new THREE.SphereGeometry(20, 10, 10);
		const spherebutton2drawer3mesh = new THREE.Mesh(spherebutton2drawer3, materialVeryGreyDark);
		spherebutton2drawer3mesh.position.set(-400, 390 , -550);		
		kly_rackObject.add(spherebutton2drawer3mesh);	
		
		//borderscreen	
		const borderscreengeometry = new THREE.BoxGeometry(10, 400, 500);
		const borderscreengeometrymesh = new THREE.Mesh(borderscreengeometry, materialGreyDark);
		borderscreengeometrymesh.position.set( -400, 0 , -810);
		kly_rackObject.add(borderscreengeometrymesh);
		
		//screen	
		const screengeometry = new THREE.BoxGeometry(10, 300, 400);
		const screengeometrymesh = new THREE.Mesh(screengeometry, materialVeryGreyDark);
		screengeometrymesh.position.set( -402, 0 , -810);
		kly_rackObject.add(screengeometrymesh);	
		
		//GreenLed1
		const greenled1 = new THREE.SphereGeometry(13, 10, 10);
		const greenled1mesh = new THREE.Mesh(greenled1, greenmaterial);
		greenled1mesh.position.set(-400, 175 , -750);		
		kly_rackObject.add(greenled1mesh);	
		
		//GreenLed2
		const greenled2 = new THREE.SphereGeometry(13, 10, 10);
		const greenled2mesh = new THREE.Mesh(greenled2, greenmaterial);
		greenled2mesh.position.set(-400, 175 , -700);		
		kly_rackObject.add(greenled2mesh);
		
	
		//borderEC
		const borderECgeometry = new THREE.BoxGeometry(10, 400, 600);
		const borderECgeometrymesh = new THREE.Mesh(borderECgeometry, materialGreyDark);
		borderECgeometrymesh.position.set( -400, -650 , -810);
		kly_rackObject.add(borderECgeometrymesh);
		
		//EC1
		const EC1geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC1geometrymesh = new THREE.Mesh(EC1geometry, materialGreyMedium);
		EC1geometrymesh.position.set( -402, -650 , -1000);
		kly_rackObject.add(EC1geometrymesh);			
		//EC2
		const EC2geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC2geometrymesh = new THREE.Mesh(EC2geometry, materialGreyMedium);
		EC2geometrymesh.position.set( -402, -650 , -950);
		kly_rackObject.add(EC2geometrymesh);			
		//EC2
		const EC3geometry = new THREE.BoxGeometry(10, 350, 40);
		const EC3geometrymesh = new THREE.Mesh(EC3geometry, materialGreyMedium);
		EC3geometrymesh.position.set( -402, -650 , -900);
		kly_rackObject.add(EC3geometrymesh);	
		

		
		return kly_rackObject;
	}
